#include "db_interface.h"
#include "oid.h"
#include "psi_term.h"
#include "exc.h"
#include "psi_obj.h"
#include "obj_stream.h"
#include "defs.h"

extern "C" {
#include "Source/copy.h"
void fetch_psi_term(ptr_psi_term*);
void deref_goal_args(ptr_node n);
void feature_added2psi_term(ptr_psi_term t);
void check_hashed_psi_terms();
//void check_dbpointer_data(GENERIC);
int ok_dbpointers(GENERIC d1, GENERIC d2);
extern jmp_buf env;

}

extern int fetch_depth;
void fetch_psi_term(ptr_psi_term* t) {
  ptr_psi_term& term = *t;
  {
    //    if (term->type==psi_id && term->dbpointer) {
    print_debug((cerr << "*** Dereferencing db pointer" << "\n"));
    //    PsiIdTerm id(term); // psiidterm call
    //    id.swizzle();
    fetch_db_psi_term(term, fetch_depth);
    deref_ptr(term);
      //    }
  }
}

void deref_goal_args(ptr_node n)
{
  ptr_psi_term t;
  
  if (n) {
    deref_goal_args(n->right);
    t = (ptr_psi_term) (n->data);
    deref_ptr(t);
    deref_db_ptr(t);
    deref_goal_args(n->left);
  }

}

void feature_added2psi_term(ptr_psi_term term) {
  {
    //    PsiIdTerm id(t);
    //    id.feature_added();
    deref_ptr(term);
    ObjectId& object_id = PSIID(term->dbpointer);
    UNEXPECTED( (!object_id.is_hashed()),
		"unexpected error in feature_added2psi_term()");
    object_id.feature_added2psi_term();
  }
}

// void check_dbpointer_data(GENERIC dbpointer) {
//   // gc doesnt work if this routine is called in memory_check(). 
//   // object_id.dbpointer_d is garbage collected if object_id is hashed. 
//   // so use object_id.dbpointer_d only if it is hashed.

//   ObjectId & object_id = PSIID(dbpointer);
//   object_id.check_data();
// }

void check_hashed_psi_terms() {
  //  cerr << "check_hashed_psi_terms" << "\n";
  if (object_stream.is_set()) object_stream->check_data();
  // cerr << "check_hashed_psi_terms_over" << "\n";
}

int ok_dbpointers(GENERIC d1, GENERIC d2) {
  ObjectId& id1 = PSIID(d1);
  ObjectId& id2 = PSIID(d2);
  return (id1.file()==id2.file());
}

