#ifndef dlist_hdr
#define dlist_hdr

#include <iostream.h>
#include "extern-c++.h"
extern long pass;

class DList;

#define VALID_LIFE_ADDRESS(A) ((GENERIC)A>=mem_base && (GENERIC)A<mem_limit)
#define OUTPUT(t,n,p) os << " (this: " << (void*) t << " n: " << (void*)n << " p: " << (void*)p << ") "

//////////////////////
// CLASS B_DL_Node //
////////////////////
class B_DL_Node {
	
  friend class DList;	

private:
  B_DL_Node* next1_d;		// Pointer to next node
  B_DL_Node* prev1_d;		// Pointer to previous node

protected:
  B_DL_Node():next1_d(NULL), prev1_d(NULL) {}

  void insert_node(B_DL_Node* p, B_DL_Node* n);
  B_DL_Node* remove_node1(void);

  //  virtual void output_data(ostream&)const=0;
  virtual void output_data(ostream& os)const{
    os << " DL_Node: "; OUTPUT(this,next1_d,prev1_d); }

public:
  virtual ~B_DL_Node();

  B_DL_Node* next1( void ) const
    { return next1_d && next1_d->header_node() ? 
	(B_DL_Node*)NULL : next1_d; }; 
  B_DL_Node* prev1( void ) const
    { return prev1_d && prev1_d->header_node() ? 
	(B_DL_Node*)NULL: prev1_d; }; 
  
  virtual int header_node() const { return 0; };
  B_DL_Node* prepend1(B_DL_Node* n) 
    { if (n) n->insert_node(prev1_d, this); return n; };
  B_DL_Node* append1(B_DL_Node* n)
    { if (n) n->insert_node(this, next1_d); return n;};
  B_DL_Node* remove1(void) { return remove_node1(); };
  virtual void remove(void) { remove_node1(); }
  virtual void check_data();
  friend ostream& operator<<(ostream& os, const B_DL_Node& n);

};

///////////////////
// CLASS DL_Node //
//////////////////
template<class T> class DL_Node:public B_DL_Node {

protected:
  T data_d;

public:
  DL_Node():data_d((T)NULL) {};
  DL_Node(T d):data_d(d) {};
  ~DL_Node() {};

  T data() const {return data_d; };

protected:
  void output_data(ostream& os)const { os << data_d; };

};


//////////////////
// CLASS DList //
////////////////
class DList {

class HdrNode: public B_DL_Node {
public:
  int header_node() const { return 1; };
protected:
  void output_data(ostream&)const {};
};

protected:
  HdrNode first_d;		// Pointer to first node
  HdrNode last_d;		// Pointer to last node

public:
  DList();
  virtual ~DList();
  
  void prepend(B_DL_Node*); 
				// insert at the start of list
  void append(B_DL_Node*);	
				// append to end of the list
  void delete_a();	// delete at the start of list
  void delete_e();	// delete at the end of list
  B_DL_Node* remove_a();	// Remove start node from list, 
				// do NOT delete node.
  B_DL_Node* remove_e();	// Remove end node from list, 
				// do NOT delete node.

  B_DL_Node* first() const { return first_d.next1(); };
  B_DL_Node* last() const { return last_d.prev1(); };
  virtual void check_data();
  virtual int length();
  friend ostream& operator<<( ostream &, const DList& );

protected:
  virtual void output_data(ostream& os)const;

private:
  DList(const DList&);
  void operator=(const DList&);
};

#endif
