#ifndef page_hdr
#define page_hdr

#include <iostream.h>

class Page;

#include "odb.h"
#include "oid.h"

class Cache;

/////////////////
// CLASS Page //
///////////////
class Page {

protected:
  const PageKey* page_id;
  Cache* cache_d;
  PageInfo* info_d;

public:
  ~Page();

  void read_page(); 
  void flush_page(); // page is flushed if dirty.

  int page_type()const;
  int same_page(const PageKey& p_key) {
    return (*page_id==p_key);
  }
  const PageKey& key() {return *page_id; }
  ObjFile* file() const { return page_id->file(); }
  page_num pnum() const { return page_id->pnum(); }

  friend ostream& operator<<(ostream&, const Page&);

protected:
  Page();

  void make_new()const;

  virtual void output_data(ostream& os)const;

private:
  Page(const Page&);
  void operator=(const Page&);
};

#endif
