#include <math.h>

#include "rdb.h"
#include "OdbSource/extern-c++.h"
#include "sql_psi.h"
#include "OdbSource/exc.h"

/****************Externally defined variables*********/

/****************Global Varaibles********************/

/****************Externally defined functions*********/
extern ptr_definition dbnull;

int S2P_Value:: extract_symbol_from_string(char* str, int len, 
					       char* before_hash, 
					       char* after_hash) 

{
  char *m, *s;
  int is_string=1;
  int count=0;

  m=before_hash;
  s=str;
  while(count < len){
    if (*s == '#') {
      count++;
      s++; 
      if (count < len || *s != '#') {	
	is_string=0;
	break;
      }
    }
    count++;
    *(m++) = *(s++);
  }
  *m = '\0';

  if (!is_string) {
    m=after_hash;
    while(count < len) {
      count++;
      *(m++) = *(s++);
      if (*s=='#') {
	count++;
	s++;
      }
    }
  }
  *m = '\0';

  return is_string;
}

/******** col2sort
  
*/
void S2P_Value:: col2sort(int column_count)
{
  ptr_psi_term term;
  ptr_module module;
  REAL value;
  char *value2, symbol;

  term = stack_psi_term(4);

  if (tuple[column_count].length==0 
      && tuple[column_count].data==NULL) {
    term->type=dbnull; 
  }
  else {
    if (tuple[column_count].type==DB_NUMTYPE) {
      value = *(REAL *) tuple[column_count].data;
      term->value=(GENERIC)heap_alloc(sizeof(REAL));
      *(REAL *)term->value=value;
      if (value == floor(value)) 
	term->type=integer;
      else 
	term->type=real;
    }
    else if (tuple[column_count].type==DB_STRTYPE) {
      char before_hash[tuple[column_count].length + 1];
      char after_hash[tuple[column_count].length + 1];
      int is_string = extract_symbol_from_string(tuple[column_count].data, 
						 tuple[column_count].length,
						 before_hash, after_hash);
      if (is_string){
	term->type=quoted_string;
	value2=(char *) heap_alloc(strlen(before_hash)+1);
	strcpy(value2, before_hash);
	term->value=(GENERIC)value2;
      }
      else{
//	term->type = update_symbol(NULL,value2);
	ptr_module module=create_module(before_hash);
	term->type = PsiTerm:: update_symbol(module, after_hash);
      }
    }
    else {
	dberror << "in col2sort: unknown type";
	throw_error();
      }
  }

  stack_insert_copystr(tuple[column_count].col_name, 
	       &query_result->attr_list, term);
  column_count++;

}

/********  tuple2psi
  
*/
void S2P_Value:: tuple2psi(Attribute* tup, int noc)
{
  tuple = tup;

  query_result = stack_psi_term(4);
  for(int i=0; i < noc; i++)
    col2sort(i);
  UNEXPECTED( (!query_result),
	     "unexpected null value in S2P_Value:: tuple2psi" )
}



