#ifndef sybase_hdr
#define sybase_hdr

extern "C" {
#include <sybfront.h>
#include <sybdb.h>
}

#include "rdb_channel.h"


class Sybase: public RdbChannel {

protected:
  DBPROCESS* db_stream;

public:
  Sybase(char* user, char* user_pwd, char* server);
  ~Sybase();


public:
  char* db_name();
  void database(char* d);

  void append_query(char* query, char* prefix, char* suffix);
  void sql_send();
  void sql_ok();
  long execute();
  long data();
  void cancel_query();
  void cancel_all();

protected:
  void safe_str(char* des, char* src);
  void output_data(ostream&)const;

private:
  void init();
  void connect(char* user, char* user_pwd, char* server);
  void close();

  static void db_exit();
};

#endif
